package com.caimei365.tools.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.caimei365.tools.mapper.CmBehaviorRecordMapper;
import com.caimei365.tools.model.po.*;
import com.caimei365.tools.service.CmBehaviorRecordService;
import io.netty.util.internal.MathUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.math.BigDecimal;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Description
 *
 * @author : Charles
 * @date : 2022/11/2
 */
@Slf4j
@Service
public class CmBehaviorRecordServiceImpl implements CmBehaviorRecordService {

    @Autowired
    private CmBehaviorRecordMapper recordMapper;

    @Override
    public void insertRecord(IpSavePo ipSavePo) {
        if ("/user/record/Statistics".equals(ipSavePo.getRequestUrl().trim()) && !ipSavePo.getIp().equals("106.55.202.118")) {
            log.info("用户行为记录=================》" + ipSavePo.getIp());
            CmBehaviorRecordPo cmBehaviorRecordPo = new CmBehaviorRecordPo();
            String region = "";
            cmBehaviorRecordPo.setIP(ipSavePo.getIp());
            if (StringUtils.isNotBlank(ipSavePo.getUserId())) {
                cmBehaviorRecordPo.setUserId(ipSavePo.getUserId());
            } else {
                cmBehaviorRecordPo.setUserId("0");
            }
            if (ipSavePo.getParams().contains("userId") || ipSavePo.getParams().contains("productId")) {
                String[] split = ipSavePo.getParams().split("&");
                for (String s : split) {
                    String str = s.trim();
                    // 页面路径
                    if (str.startsWith("pagePath") && str.contains("=")) {
                        String[] split1 = str.split(str.substring(str.indexOf("="), str.indexOf("=") + 1), 2);
                        if (split1.length > 1) {
                            String value = split1[1];
                            String trim = value.trim();
                            if (StringUtils.isNotBlank(trim)) {
                                String decode = null;
                                try {
                                    decode = java.net.URLDecoder.decode(trim, "UTF-8");
                                    if (decode.contains("%")) {
                                        decode = java.net.URLDecoder.decode(decode, "UTF-8");
                                    }
                                } catch (UnsupportedEncodingException e) {
                                    e.printStackTrace();
                                }
                                cmBehaviorRecordPo.setPagePath(decode);
                            }
                            if (StringUtils.isEmpty(cmBehaviorRecordPo.getPagePath())) {
                                log.info("页面路径pagePath 值为====》" + trim);
                                return;
                            }
                        }
                    }
                    // 页面类型
                    if (str.startsWith("pageType") && str.contains("=")) {
                        String[] split1 = str.split("=");
                        // 赋默认值
                        cmBehaviorRecordPo.setPageType(0);
                        if (split1.length > 1) {
                            String value = split1[1];
                            String trim = value.trim();
                            if (StringUtils.isNotBlank(trim)) {
                                int parseInt = Integer.parseInt(trim);

                                cmBehaviorRecordPo.setPageType(parseInt);
                            }
                        }
                    }
                    // 页面标签
                    cmBehaviorRecordPo.setPageLabel(" ");
                    if (str.startsWith("pageLabel") && str.contains("=")) {
                        String[] split1 = str.split("=");
                        cmBehaviorRecordPo.setPageLabel("");
                        if (split1.length > 1) {
                            String value = split1[1];
                            String trim = value.trim();
                            if (StringUtils.isNotBlank(trim)) {

                                // 接口参数解码
                                String decode = null;
                                try {
                                    decode = java.net.URLDecoder.decode(trim, "UTF-8");
                                    if (decode.contains("%")) {
                                        decode = java.net.URLDecoder.decode(decode, "UTF-8");
                                    }
                                } catch (UnsupportedEncodingException e) {
                                    e.printStackTrace();
                                }
                                cmBehaviorRecordPo.setPageLabel(decode);
                            }
                        }
                    }
                    // 用户行为记录 or roos页面统计
                    if (str.startsWith("behaviorType") && str.contains("=")) {
                        String[] split1 = str.split("=");
                        cmBehaviorRecordPo.setBehaviorType("1");
                        if (split1.length > 1) {
                            String value = split1[1];
                            String trim = value.trim();
                            if (StringUtils.isNotBlank(trim)) {
                                if (!trim.equals("null")) {
                                    cmBehaviorRecordPo.setBehaviorType(trim);
                                } else {
                                    cmBehaviorRecordPo.setBehaviorType("0");
                                }

                            }
                        }
                    }
                    // 供应商Id
                    if (str.startsWith("shopId") && str.contains("=")) {
                        String[] split1 = str.split("=");
                        cmBehaviorRecordPo.setShopId(null);
                        if (split1.length > 1) {
                            String value = split1[1];
                            String trim = value.trim();
                            if (StringUtils.isNotBlank(trim)) {
                                if (!trim.equals("null")) {
                                    cmBehaviorRecordPo.setShopId(Integer.parseInt(trim));
                                } else {
                                    cmBehaviorRecordPo.setShopId(null);
                                }
                            }
                        }
                    }
                    // 商品ID
                    if (str.startsWith("productId") && str.contains("=")) {
                        String[] split1 = str.split("=");
                        if (split1.length > 1) {
                            String value = split1[1];
                            String trim = value.trim();
                            if (StringUtils.isNotBlank(trim)) {
                                cmBehaviorRecordPo.setProductId(trim);
                            }
                        }
                    }
                    // 访问客户端 0：网站 1：小程序
                    if (str.startsWith("accessClient") && str.contains("=")) {
                        String[] split1 = str.split("=");
                        cmBehaviorRecordPo.setAccessClient("0");
                        if (split1.length > 1) {
                            String value = split1[1];
                            String trim = value.trim();
                            if (StringUtils.isNotBlank(trim)) {
                                cmBehaviorRecordPo.setAccessClient(trim);
                            }
                        }
                    }
                    // 浏览器链接
                    if (str.startsWith("referer") && str.contains("=")) {
                        String[] split1 = str.split("=");
                        if (split1.length > 1) {
                            String value = split1[1];
                            String trim = value.trim();
                            if (StringUtils.isNotBlank(trim)) {
//                                log.info("referer============》"+trim);
                                // 浏览器链接
                                cmBehaviorRecordPo.setReferer(trim);
                                // 访问来源
                                String source = source(trim);
                                cmBehaviorRecordPo.setAccessSource(source);
                            }
                        }
                    }
                    // 设置删除标记 判定爬虫
                    cmBehaviorRecordPo.setDelFlag("0");
                    // 浏览器userAgent
                    if (str.startsWith("userAgent") && str.contains("=")) {
                        String[] split1 = str.split("=");
                        if (split1.length > 1) {
                            String value = split1[1];
                            String trim = value.trim();
                            if (StringUtils.isNotBlank(trim)) {
                                log.info("userAgent============》" + trim);
                                // 浏览器userAgent
                                cmBehaviorRecordPo.setUserAgent(trim);
                                if (boolReptiles(trim)) {
                                    cmBehaviorRecordPo.setDelFlag("1");
                                }
                            }
                        }
                    }
                }
            }

            Date date = new Date();
            cmBehaviorRecordPo.setAccessTime(date);
            cmBehaviorRecordPo.setAccessDuration("5000");
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
            String format = simpleDateFormat.format(date);
            cmBehaviorRecordPo.setAccessDate(format);
            cmBehaviorRecordPo.setIsReckon("0");
            // 确定ip所属地

            try {
                region = recordIp(ipSavePo.getIp());
            } catch (IOException e) {
                e.printStackTrace();
            }
            cmBehaviorRecordPo.setRegion(region);
            recordMapper.insertRecord(cmBehaviorRecordPo);

            int recordId = cmBehaviorRecordPo.getRecordID();
            if (cmBehaviorRecordPo.getShopId() != null) {
                if (14 != cmBehaviorRecordPo.getPageType()) {
                    if (StringUtils.isNotBlank(cmBehaviorRecordPo.getPageLabel())) {
                        List<String> strList = new ArrayList<>();
                        // 页面标签在含有多个，包含 ， 是可分割，进行分割作为关键词
                        if (cmBehaviorRecordPo.getPageLabel().contains(",")) {
                            String[] split = cmBehaviorRecordPo.getPageLabel().split(",");
                            for (String s : split) {
                                strList.add(s);
                            }
                        } else {
                            strList.add(cmBehaviorRecordPo.getPageLabel());
                        }
                        // 供应商id
                        List<Integer> shopIds = recordMapper.shopIds(strList);
                        if (shopIds.size() > 0) {
                            for (Integer shopId : shopIds) {
                                recordMapper.insertShopId(recordId, shopId);
                            }
                        }
                    }
                } else {
                    Integer id = recordMapper.selShopId(cmBehaviorRecordPo.getShopId());
                    if (id != null) {
                        recordMapper.insertShopId(recordId, cmBehaviorRecordPo.getShopId());
                    }
                }
            }
        }
    }

    @Override
    public void updateBehaviorTime() {
        log.info("计算实际访问时长==================》");
        long t1 = 0;
        long t2 = 0;
        Long duration = 0L;
        CmBehaviorRecordPo cmBehaviorRecordPo = new CmBehaviorRecordPo();
        CmBehaviorRecordPo cmBehaviorRecord = new CmBehaviorRecordPo();
        Date date = new Date();
        // 获取当前时间日期
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
        String format = simpleDateFormat.format(new Date(date.getTime() - 600000));
        cmBehaviorRecordPo.setAccessDate(format);
        // 当天访问系统ip和userID
        List<CmBehaviorRecordPo> recordPos = recordMapper.toDateRecode(cmBehaviorRecordPo);
        for (CmBehaviorRecordPo behaviorRecordPo : recordPos) {
            SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            // 当前时间
            String timeEnd = dateFormat.format(date);
            //  一小时前时间
            Calendar c = Calendar.getInstance();
            c.set(Calendar.HOUR_OF_DAY, (c.get(Calendar.HOUR_OF_DAY) - 1));
            String timeStart = dateFormat.format(c.getTime());

            behaviorRecordPo.setStartTime(timeStart);
            behaviorRecordPo.setEndTime(timeEnd);
            // 获取一个小时之内的数据
            List<CmBehaviorRecordPo> recordPoList = recordMapper.toDateIPTimeRecode(behaviorRecordPo);
            if (recordPoList.size() <= 0) {
                continue;
            }
            for (int i = 0; i < recordPoList.size(); i++) {
                if (i != recordPoList.size() - 1) {
                    t1 = recordPoList.get(i).getAccessTime().getTime();
                    t2 = recordPoList.get(i + 1).getAccessTime().getTime();
                    duration = t2 - t1;
                    // 修改实际访问时长
                    cmBehaviorRecord.setRecordID(recordPoList.get(i).getRecordID());
                    cmBehaviorRecord.setAccessDuration(duration.toString());
                    cmBehaviorRecord.setIsReckon("1");
                    recordMapper.updateDuration(cmBehaviorRecord);
                }
            }
        }
    }

    @Override
    public void setIpAddress(Integer startId, Integer endId) throws IOException {
        List<CmUserPo> list = recordMapper.findList(startId, endId);
        String region = "";
        for (CmUserPo user : list) {
            try {
                // 获取ip所在地
                region = recordIp(user.getRegisterIP());
                user.setIpAddress(region);
                recordMapper.updateOldData(user);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public void setProductCostProportional() {
        List<CmSkuPo> skuList = recordMapper.skuList();
        skuList.forEach(sku -> {
            if (null != sku.getPrice() && 0 != sku.getPrice()) {
                // 供应商比例
                double shopPercent = (sku.getCostPrice()/sku.getPrice()*100);
                double rint = Math.rint(shopPercent);
                // 分账组织佣金比例
                double organizePercent = 0d;
                // 分账采美佣金比例
                double cmPercent = 100d - rint;
                sku.setShopPercent(rint);
                sku.setOrganizePercent(organizePercent);
                sku.setCmPercent(cmPercent);
                // 成本类型 -> 比例成本
                sku.setCostCheckFlag(2);
                recordMapper.updateSku(sku);
            }
        });
    }

    @Override
    public void updateBehaviorUser() {
        log.info("====合并IP====");
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        Date date = new Date();
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        calendar.add(Calendar.DAY_OF_MONTH, -1);
        Date time = calendar.getTime();
        String format = dateFormat.format(time);
        // 前一天数据身份中是否只有 机构-游客、供应商-游客
        List<CmBehaviorRecordPo> countNumList = recordMapper.countNum(format);
        if (countNumList.size() != 0 && countNumList != null) {
            for (CmBehaviorRecordPo countNum : countNumList) {
                if (countNum.getCount() == 2) {
                    // 查询机构/供应商ip、userID，用于调整游客数据
                    CmBehaviorRecordPo recordPo = recordMapper.userIdAcc(countNum.getIP(), format);
                    // 查询游客数据
                    List<CmBehaviorRecordPo> behaviorList = recordMapper.selBehaviorList(countNum.getIP(), format);
                    // 将游客数据中的ip和userId修改为机构/供应商数据
                    for (CmBehaviorRecordPo cmBehaviorRecordPo : behaviorList) {
                        cmBehaviorRecordPo.setIP(recordPo.getIP());
                        cmBehaviorRecordPo.setUserId(recordPo.getUserId());
                        recordMapper.updateBehavior(cmBehaviorRecordPo);
                    }
                }
            }
        }
    }

    /**
     * 昨日用户行为列表数据生成
     */
    @Override
    public void insertBehaviorUser() {
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(new Date());
        calendar.add(Calendar.DAY_OF_MONTH, -1);
        Date time = calendar.getTime();
        String format = dateFormat.format(time);
        // 获取昨天数据
        List<CmBehaviorRecordPo> yesterdayList = recordMapper.selYesterdayList(format);
        // 详细数据
        List<CmBehaviorRecordPo> selDataList = recordMapper.selDataList(format);
        // 获取供应商关联所有标签
        List<String> keywords = recordMapper.shopKeyword();
        for (CmBehaviorRecordPo data : yesterdayList) {
            ArrayList<String> item = new ArrayList();
            ArrayList<String> shopNames = new ArrayList();
            // 当ip过长，有多个ip时已第一个IP为准
            if (data.getIP().contains(",")) {
                String[] split = data.getIP().split(",");
                data.setIP(split[0].trim());
            }
            int num = 0;
            for (CmBehaviorRecordPo recordPo : selDataList) {
                if (recordPo.getIP().equals(data.getIP()) && recordPo.getUserId().equals(data.getUserId())) {
                    // 标签信息 对多存储10个
                    if (num < 10) {
                        if (StringUtils.isNotBlank(recordPo.getPageLabel())) {
                            if (recordPo.getPageLabel().contains(",")) {
                                String[] split = recordPo.getPageLabel().split(",");
                                for (String s : split) {
                                    if (keywords.contains(s)) {
                                        if (!item.contains(s)) {
                                            item.add(s);
                                            num++;
                                        }
                                    }
                                }
                            } else {
                                if (keywords.contains(recordPo.getPageLabel())) {
                                    if (!item.contains(recordPo.getPageLabel())) {
                                        item.add(recordPo.getPageLabel());
                                        num++;
                                    }
                                }
                            }

                        }
                    }
                    if (StringUtils.isNotBlank(recordPo.getRelevanceShop()) && !shopNames.contains(recordPo.getRelevanceShop())) {
                        shopNames.add(recordPo.getRelevanceShop());
                    }
                }
            }
            data.setLabel(StringUtils.strip(item.toString(), "[]"));
            data.setRelevanceShop(StringUtils.strip(shopNames.toString(), "[]"));
            // 数据插入
            recordMapper.insertYesterdayList(data);
        }
        log.info("====昨日用户行为列表数据已生成====");
    }

    /**
     * 生成用户行为今日列表数据 数据一小时覆盖
     */
    @Override
    public void insertTodayData() {
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        String format = dateFormat.format(new Date());


        // 今日用户行为数据
        List<CmBehaviorRecordPo> todayData = recordMapper.selTodayData(format);
        // 清除今日用户行为记录
        recordMapper.delTodayData();
        // 生成今日用户行为记录
        int id = 1;
        // 所有用户供应商数据
        List<CmBehaviorRecordPo> selDataList = recordMapper.selDataList(format);
        List<String> keywords = recordMapper.shopKeyword();
        for (CmBehaviorRecordPo data : todayData) {
            ArrayList<String> item = new ArrayList();
            ArrayList<String> shopNames = new ArrayList();
            // 当ip过长，有多个ip时已第一个IP为准
            if (data.getIP().contains(",")) {
                String[] split = data.getIP().split(",");
                data.setIP(split[0].trim());
            }
            int num = 0;
            data.setRecordID(id);
            id++;
            for (CmBehaviorRecordPo recordPo : selDataList) {
                if (recordPo.getIP().equals(data.getIP()) && recordPo.getUserId().equals(data.getUserId())) {
                    // 标签信息
                    if (num < 10) {
                        if (StringUtils.isNotBlank(recordPo.getPageLabel())) {
                            if (recordPo.getPageLabel().contains(",")) {
                                String[] split = recordPo.getPageLabel().split(",");
                                for (String s : split) {
                                    if (keywords.contains(s)) {
                                        if (!item.contains(s)) {
                                            item.add(s);
                                            num++;
                                        }
                                    }
                                }
                            } else {
                                if (keywords.contains(recordPo.getPageLabel())) {
                                    if (!item.contains(recordPo.getPageLabel())) {
                                        item.add(recordPo.getPageLabel());
                                        num++;
                                    }
                                }
                            }

                        }
                    }
                    // 供应商
                    if (StringUtils.isNotBlank(recordPo.getRelevanceShop()) && !shopNames.contains(recordPo.getRelevanceShop())) {
                        shopNames.add(recordPo.getRelevanceShop());
                    }
                }
            }
            data.setLabel(StringUtils.strip(item.toString(), "[]"));
            data.setRelevanceShop(StringUtils.strip(shopNames.toString(), "[]"));
            recordMapper.inBehaviorToday(data);
            log.info("====今日用户行为列表数据已生成====");
        }
    }

    @Override
    public void updateClubAddress(Integer startId, Integer endId) {
        List<CmBehaviorRecordPo> recordPoList = recordMapper.selRegisterIP(startId, endId);
        if (recordPoList.size() > 0) {
            recordPoList.forEach(r -> {
                if (StringUtils.isNotBlank(r.getRegisterIp()) && (null == r.getProvinceId() && null == r.getCityId())) {
                    log.info("个人机构地址初始化=====》"+r.getClubId());
                    try {
                        Map<String, String> map = recordAddress(r.getRegisterIp());
                        if (!map.isEmpty()) {
                            // 省份
                            String regionPro = map.get("regionPro");
                            Integer provinceId = recordMapper.selProvince(regionPro);
                            // 市
                            String regionCity = map.get("regionCity");
                            AddressPo addressPo = recordMapper.selCity(regionCity);

                            Integer cityId = null;
                            if (null != provinceId) {
                                if (null != addressPo) {
                                    if (null != addressPo.getProvinceId()) {
                                        if (addressPo.getProvinceId().equals(provinceId)) {
                                            // 省份id与地址表的省份地址对应 取地址表地址 机构给予 省、市地址
                                            recordMapper.upClubAddress(r.getClubId(), provinceId, addressPo.getCityId());
                                        } else {
                                            // 省份id与地址表的省份地址不对应 取地址表地址
                                            provinceId = addressPo.getProvinceId();
                                            recordMapper.upClubAddress(r.getClubId(), provinceId, addressPo.getCityId());
                                        }
                                    } else {
                                        // 地址表没有省份id 机构给予省份地址Id
                                        recordMapper.upClubAddress(r.getClubId(), provinceId, cityId);
                                    }
                                } else {
                                    // 省份不为空 市为空，机构给予省份地址Id
                                    recordMapper.upClubAddress(r.getClubId(), provinceId, cityId);
                                }
                            }
                        }
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            });
        }
    }

    /**
     * 页面统计
     */
    @Override
    public void pageStatistics() {
        log.info("页面统计数据");
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        Calendar instance = Calendar.getInstance();
        instance.setTime(new Date());
        instance.add(Calendar.DAY_OF_MONTH, -1);
        Date time = instance.getTime();
        String format = dateFormat.format(time);
        log.info("dateTime========"+format);
        // 统计供应商
        List<Integer> shopIds = recordMapper.getShopId();
        shopIds.forEach( s -> {
            log.info("统计供应商数据");
            // 检索供应商统计信息
            CmBehaviorRecordPo behavior = recordMapper.getBehaviorList(format, 14, s.toString());
            CmPageShopPo cmPageShopPo = new CmPageShopPo();
            cmPageShopPo.setShopId(s);
            cmPageShopPo.setAccessNumber(Integer.parseInt(behavior.getNumber()));
            cmPageShopPo.setShopLink(behavior.getPagePath());
            cmPageShopPo.setAccessDuration(behavior.getAccessDuration());
            cmPageShopPo.setAccessDate(format);
            // 加入统计供应商数据
            recordMapper.insertPageShop(cmPageShopPo);
            log.info("统计供应商商品数据");
            // 需要统计的供应商商品
            List<Integer> productIdIdList = recordMapper.getProductId(s);
            for (Integer productId : productIdIdList) {
                behavior = recordMapper.getBehaviorList(format, 6, productId.toString());
                CmPageShopProductPo productPo = new CmPageShopProductPo();
                productPo.setShopId(s);
                productPo.setProductId(productId);
                productPo.setLink(behavior.getPagePath());
                productPo.setAccessNumber(Integer.parseInt(behavior.getNumber()));
                productPo.setAccessDuration(behavior.getAccessDuration());
                productPo.setAccessDate(format);
                // 加入统计供应商商品数据
                recordMapper.insertPageProduct(productPo);
            }
            // 需要统计的供应商文章
            List<Integer> infoIdList = recordMapper.getShopInfoId(s);
            for (Integer infoId : infoIdList) {
                behavior = recordMapper.getBehaviorList(format, 11, infoId.toString());
                CmPageShopInfoPo infoPo = new CmPageShopInfoPo();
                infoPo.setShopId(s);
                infoPo.setInfoId(infoId);
                infoPo.setLink(behavior.getPagePath());
                infoPo.setAccessNumber(Integer.parseInt(behavior.getNumber()));
                infoPo.setAccessDuration(behavior.getAccessDuration());
                infoPo.setAccessDate(format);
                // 添加供应商文章统计数据
                recordMapper.insertPageInfo(infoPo);
            }
            // 需要统计的供应商搜索词
            List<SearchFrequencyVo> keywordList = recordMapper.getShopKeywordId(s);
            for (SearchFrequencyVo keyword : keywordList) {
                behavior = recordMapper.getBehaviorList(format, 8, keyword.getKeyword());
                CmPageShopKeywordPo keywordPo = new CmPageShopKeywordPo();
                keywordPo.setShopId(s);
                keywordPo.setSearchId(keyword.getId());
                keywordPo.setLink(behavior.getPagePath());
                keywordPo.setAccessNumber(Integer.parseInt(behavior.getNumber()));
                keywordPo.setAccessDuration(behavior.getAccessDuration());
                keywordPo.setAccessDate(format);
                // 添加供应商搜索词统计数据
                recordMapper.insertPageKeyword(keywordPo);
            }
        });
        log.info("页面统计结束");
    }


    // 获取IP对应地址 ---- 太平洋
    public static String recordIp(String ip) throws IOException {
        URL url = null;
        HttpURLConnection connection = null;
        String encoding = "gbk";
        String text = "";
        String line = "";
        String region = "";
        String urlStr = "http://whois.pconline.com.cn/ipJson.jsp?ip=" + ip + "&json=true";
        try {
            url = new URL(urlStr);
            connection = (HttpURLConnection) url.openConnection();    //新建链接实例
            connection.setConnectTimeout(20000);    //设置链接超时时间，单位毫秒
            connection.setReadTimeout(20000);        //设置读取数据超时时间，单位毫秒
            connection.setDoOutput(true);        //是否打开输出流true|false
            connection.setDoInput(true);        //是否打开输入流true|false
            connection.setRequestMethod("GET");        // 提交方式get|post
            connection.setUseCaches(false);        // 是否加入缓存true|false
            connection.connect();    //打开链接端口

            BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream(), encoding));    // 往对端写完数据对端服务器返回数据。以BufferedReader流来读取

            while ((line = reader.readLine()) != null) {
                text += line + "\n";
            }
            reader.close();

            JSONObject jsonObject = JSONObject.parseObject(text);
            region = jsonObject.get("addr").toString();
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } finally {
            if (connection != null) {
                connection.disconnect();    //关闭连接
            }
        }
        return region;
    }
    // 获取IP对应地址 ---- 太平洋
    public static Map<String, String> recordAddress(String ip) throws IOException {
        URL url = null;
        HttpURLConnection connection = null;
        String encoding = "gbk";
        String text = "";
        String line = "";
        String regionPro = "";
        String regionCity = "";
        Map<String,String> map = new HashMap<>();
        String urlStr = "http://whois.pconline.com.cn/ipJson.jsp?ip=" + ip + "&json=true";
        try {
            url = new URL(urlStr);
            connection = (HttpURLConnection) url.openConnection();    //新建链接实例
            connection.setConnectTimeout(20000);    //设置链接超时时间，单位毫秒
            connection.setReadTimeout(20000);        //设置读取数据超时时间，单位毫秒
            connection.setDoOutput(true);        //是否打开输出流true|false
            connection.setDoInput(true);        //是否打开输入流true|false
            connection.setRequestMethod("GET");        // 提交方式get|post
            connection.setUseCaches(false);        // 是否加入缓存true|false
            connection.connect();    //打开链接端口

            BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream(), encoding));    // 往对端写完数据对端服务器返回数据。以BufferedReader流来读取

            while ((line = reader.readLine()) != null) {
                text += line + "\n";
            }
            reader.close();

            JSONObject jsonObject = JSONObject.parseObject(text);
            // 省份
            regionPro = jsonObject.get("pro").toString();
            map.put("regionPro", regionPro);
            // 市区
            regionCity = jsonObject.get("city").toString();
            map.put("regionCity", regionCity);

        } catch (MalformedURLException e) {
            e.printStackTrace();
        } finally {
            if (connection != null) {
                connection.disconnect();    //关闭连接
            }
        }
        return map;
    }

    private String source(String link) {
        if (link.contains("www.baidu.com")) {
            return "1";
        }
        if (link.contains("www.so.com")) {
            return "2";
        }
        if (link.contains("www.google.cn")) {
            return "3";
        }
        if (link.contains("m.sm.cn")) {
            return "4";
        }
        if (link.contains("toutiao.com")) {
            return "5";
        }
        if (link.contains("www.sogou.com")) {
            return "6";
        }
        if (link.contains("servicewechat.com")) {
            return "7";
        }
        if (link.contains("www.caimei365.com")) {
            return "0";
        }
        if (link.contains("zzjtest.gz.aeert.com")) {
            return "0";
        }
        return null;
    }

    private boolean boolReptiles(String userAgent) {
        if (userAgent.contains("serpstatbot") || userAgent.contains("spider") || userAgent.contains("Googlebot") || userAgent.contains("bingbot")
                || userAgent.contains("SeznamBot") || userAgent.contains("YisouSpider") || userAgent.contains("petalbot") || userAgent.contains("YandexBot")
                || userAgent.contains("AhrefsBot") || userAgent.contains("BingPreview/1.0b")) {
            return true;
        }
        return false;
    }
}
